// Copyright 2021 Tencent Inc. All rights reserved.

// API version: 1.2.3

// Code generated by WechatPay APIv3 Generator based on [OpenAPI
// Generator](https://openapi-generator.tech); DO NOT EDIT.

package com.wechat.pay.java.service.payments.model;

import com.google.gson.annotations.SerializedName;
import com.wechat.pay.java.core.util.GsonUtil;
import java.util.List;

/** Transaction */
public class Transaction {
  /** amount */
  @SerializedName("amount")
  private TransactionAmount amount;
  /** appid */
  @SerializedName("appid")
  private String appid;
  /** attach */
  @SerializedName("attach")
  private String attach;
  /** bankType */
  @SerializedName("bank_type")
  private String bankType;
  /** mchid */
  @SerializedName("mchid")
  private String mchid;
  /** outTradeNo */
  @SerializedName("out_trade_no")
  private String outTradeNo;
  /** payer */
  @SerializedName("payer")
  private TransactionPayer payer;
  /** promotionDetail */
  @SerializedName("promotion_detail")
  private List<PromotionDetail> promotionDetail;
  /** successTime */
  @SerializedName("success_time")
  private String successTime;
  /** tradeState */
  public enum TradeStateEnum {
    @SerializedName("SUCCESS")
    SUCCESS,

    @SerializedName("REFUND")
    REFUND,

    @SerializedName("NOTPAY")
    NOTPAY,

    @SerializedName("CLOSED")
    CLOSED,

    @SerializedName("REVOKED")
    REVOKED,

    @SerializedName("USERPAYING")
    USERPAYING,

    @SerializedName("PAYERROR")
    PAYERROR,

    @SerializedName("ACCEPT")
    ACCEPT
  }

  @SerializedName("trade_state")
  private TradeStateEnum tradeState;
  /** tradeStateDesc */
  @SerializedName("trade_state_desc")
  private String tradeStateDesc;
  /** tradeType */
  public enum TradeTypeEnum {
    @SerializedName("JSAPI")
    JSAPI,

    @SerializedName("NATIVE")
    NATIVE,

    @SerializedName("APP")
    APP,

    @SerializedName("MICROPAY")
    MICROPAY,

    @SerializedName("MWEB")
    MWEB,

    @SerializedName("FACEPAY")
    FACEPAY
  }

  @SerializedName("trade_type")
  private TradeTypeEnum tradeType;
  /** transactionId */
  @SerializedName("transaction_id")
  private String transactionId;

  public TransactionAmount getAmount() {
    return amount;
  }

  public void setAmount(TransactionAmount amount) {
    this.amount = amount;
  }

  public String getAppid() {
    return appid;
  }

  public void setAppid(String appid) {
    this.appid = appid;
  }

  public String getAttach() {
    return attach;
  }

  public void setAttach(String attach) {
    this.attach = attach;
  }

  public String getBankType() {
    return bankType;
  }

  public void setBankType(String bankType) {
    this.bankType = bankType;
  }

  public String getMchid() {
    return mchid;
  }

  public void setMchid(String mchid) {
    this.mchid = mchid;
  }

  public String getOutTradeNo() {
    return outTradeNo;
  }

  public void setOutTradeNo(String outTradeNo) {
    this.outTradeNo = outTradeNo;
  }

  public TransactionPayer getPayer() {
    return payer;
  }

  public void setPayer(TransactionPayer payer) {
    this.payer = payer;
  }

  public List<PromotionDetail> getPromotionDetail() {
    return promotionDetail;
  }

  public void setPromotionDetail(List<PromotionDetail> promotionDetail) {
    this.promotionDetail = promotionDetail;
  }

  public String getSuccessTime() {
    return successTime;
  }

  public void setSuccessTime(String successTime) {
    this.successTime = successTime;
  }

  public TradeStateEnum getTradeState() {
    return tradeState;
  }

  public void setTradeState(TradeStateEnum tradeState) {
    this.tradeState = tradeState;
  }

  public String getTradeStateDesc() {
    return tradeStateDesc;
  }

  public void setTradeStateDesc(String tradeStateDesc) {
    this.tradeStateDesc = tradeStateDesc;
  }

  public TradeTypeEnum getTradeType() {
    return tradeType;
  }

  public void setTradeType(TradeTypeEnum tradeType) {
    this.tradeType = tradeType;
  }

  public String getTransactionId() {
    return transactionId;
  }

  public void setTransactionId(String transactionId) {
    this.transactionId = transactionId;
  }

  @Override
  public String toString() {
    return GsonUtil.getGson().toJson(this);
  }
}
