package tofly.zggas.zggaspay.dao;

import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.autoconfigure.MybatisPlusPropertiesCustomizer;
import com.baomidou.mybatisplus.core.incrementer.DefaultIdentifierGenerator;
import com.baomidou.mybatisplus.core.incrementer.IdentifierGenerator;
import com.baomidou.mybatisplus.extension.plugins.MybatisPlusInterceptor;
import com.baomidou.mybatisplus.extension.plugins.inner.PaginationInnerInterceptor;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.UUID;

@Configuration
@MapperScan("tofly.zggas.zggaspay.dao.mapper")
public class MyBatisPlusConfig {
    @Bean
    public MybatisPlusPropertiesCustomizer plusPropertiesCustomizer() {
        return plusProperties ->
                plusProperties
                        .getGlobalConfig()
                        .setIdentifierGenerator(
                                new IdentifierGenerator() {
                                    @Override
                                    public Number nextId(Object entity) {
                                        return new DefaultIdentifierGenerator().nextId(entity);
                                    }

                                    @Override
                                    public String nextUUID(Object entity) {
                                        return UUID.randomUUID().toString();
                                    }
                                });
    }

    @Bean
    public MybatisPlusInterceptor mybatisPlusInterceptor() {
        MybatisPlusInterceptor interceptor = new MybatisPlusInterceptor();
        interceptor.addInnerInterceptor(new PaginationInnerInterceptor(DbType.POSTGRE_SQL));
        return interceptor;
    }
}