package tofly.zggas.zggaspay.dao.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;
import tofly.zggas.zggaspay.dao.entity.PrepayEntity;
import tofly.zggas.zggaspay.service.entity.dto.WoInfo;

import java.util.List;

@Mapper
public interface PrepayMapper extends BaseMapper<PrepayEntity> {

    @Select({"{call ${queryProcedure}(#{woId},#{total,mode=OUT,jdbcType=INTEGER})}"})
    @Options(statementType = StatementType.CALLABLE)
    int getPayTotal(String queryProcedure, String woId);
    // 获取工单状态
    //@Select({"{call ${procedure}(#{billDate},#{result,mode=OUT,jdbcType=CURSOR})}"})
    //@Options(statementType = StatementType.CALLABLE)
    List<WoInfo> getPaidList(String procedure, String billDate);
    //出账
    @Select({"{call ${procedure}(#{woId})}"})
    @Options(statementType = StatementType.CALLABLE)
    String cz(String procedure, String woId);
    //下账
    @Select({"{call ${procedure}(#{woId},#{total},#{outTradeNo},#{attach})}"})
    @Options(statementType = StatementType.CALLABLE)
    String xz(String procedure, String woId, double total, String outTradeNo, String attach);
}

